unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,
  UnitV ;

type
  TForm6 = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Edit1: TEdit;
    RichEdit1: TRichEdit;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    LastNo : integer ;
    procedure ChatDisplay(Sender: TObject);
  public
    { Public 錾 }
  end;

var
  Form6: TForm6;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm6.FormShow(Sender: TObject);
begin
   Width  := Fm6_w ;
   Height := Fm6_h ;

   LastNo := 0 ;
   RichEdit1.Lines.Clear ;
   // {̃`bge\
   ChatDisplay(Sender);

   Edit1.SetFocus;

   Timer1.Interval := TIMERWAIT1 ;
   Timer1.Enabled := True ;
end;

// I
procedure TForm6.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Timer1.Enabled := False ;

   RichEdit1.Lines.Clear ;

   Fm6_fl := False ;
   Fm6_w  := Width ;
   Fm6_h  := Height ;

   Action := caFree ;
end;

// `bgʕ\
procedure TForm6.ChatDisplay(Sender: TObject);
var
   i,m : integer ;
   s : array of string ;
   p,w,r : string ;
begin
   // {̃`bge\
   p := TABLE3 + '.N,' + TABLE2 + '.PNAME,' + TABLE3 + '.CTEXT,' ;
   p := p + TABLE3 + '.CDATE,' + TABLE3 + '.CTIME' ;
   ShortDateFormat := 'yyyymmdd' ;
   w := TABLE3 + '.CDATE=''' + DateToStr(Now) + '''' ;
   w := w + ' AND ' + TABLE3 + '.MN=' + TABLE2 + '.N' ;
   w := w + ' AND ' + TABLE3 + '.N>' + IntToStr(LastNo) ;

   SetLength(s ,TABLE3N);
   m := Form1.TableRef(p,TABLE3+','+TABLE2,w,TABLE3+'.N');
   for i:=1 to m do begin
      if (i = 1) then
         Form1.TableFirst(s)
      else
         Form1.TableNext(s);

      r := s[1] + '' + s[2] + '(' + s[3] + ' ' + s[4] + ')' ;
      RichEdit1.Lines.Add(r);
   end;
   if (m > 0) then LastNo := SInt(s[0]) ;
   Form1.TableClose ;
   s := nil ;

   RichEdit1.SelStart := Length(RichEdit1.Lines.Text);
   RichEdit1.Perform(EM_SCROLLCARET,0,0); // ŌɃJ[\ړ
end;

// ͗[Enter]L[f[^o^
procedure TForm6.Edit1KeyPress(Sender: TObject; var Key: Char);
var
   r : string ;
   fs: array of string ;
   s : array of string ;
   n : integer ;
begin
   if Key = #13 then begin
      Key := #0 ;
      r := QTrim(Edit1.Text) ;
      if (Trim(r) = '') then exit ; // 

      Timer1.Enabled := False ;

      // f[^o^
      SetLength(fs,TABLE3N);
      SetLength(s ,TABLE3N);
      fs[0] := 'N';
      fs[1] := 'MN';
      fs[2] := 'CTEXT';
      fs[3] := 'CDATE';
      fs[4] := 'CTIME';
      n  := SInt(Form1.GetMaxValue(TABLE3,'N',''))+1;
      s[0] := IntToStr(n) ;
      s[1] := IntToStr(PCno) ;
      s[2] := '''' + r + '''' ;
      ShortDateFormat := 'yyyymmdd' ;
      s[3] := '''' + DateToStr(Now) + '''' ;
      LongTimeFormat  := 'hhnnss' ;
      s[4] := '''' + TimeToStr(Now) + '''' ;
      while not(Form1.TableAdd(TABLE3,TABLE3N,fs,s)) do begin
         Inc(n) ;
         s[0] := IntToStr(n) ;
      end;
      fs := nil ;
      s  := nil ;
      //
      Edit1.Text := '' ;
      // {̃`bge\
      ChatDisplay(Sender);

      Timer1.Enabled := True ;
   end;
end;

// ^C}[FXViPCŕ`悵e\j
procedure TForm6.Timer1Timer(Sender: TObject);
begin
   Timer1.Enabled := False ;

   // {̃`bge\
   ChatDisplay(Sender);

   Timer1.Interval := TIMERWAIT1 ;
   Timer1.Enabled := True ;
end;

end.
