unit UnitV;

interface

uses
   Windows,Graphics,SysUtils,Math,clipping ;

type
   TWinClip = record
      lsc : double ;
      lx1,ly1 : double ;
      lx2,ly2 : double ;
      phx,phy   : integer ;
   end;
   TLineAtt = record
      col : integer ;   // J[R[h($000000`$ffffff)
      wid : integer ;   // (1/100mm)
      pit : double ;    // 1p^[sb`(mm)
      pn  : integer ;   // ZOg(0,2,4,6,8) 0:
      pt  : array[0..7] of double;  // sb`
      ppn : integer ;   //	OZOgNo(0-7)
      pln : double ;    //	Osb`
   end;

const
   TABLE1  = 'SECTION' ;   // e[u
   TABLE1N = 2 ;           // tB[h
   TABLE2  = 'MEMBER' ;    // o[e[u
   TABLE2N = 3 ;           // tB[h
   TABLE3  = 'CHAT' ;      // `bgf[^e[u
   TABLE3N = 5 ;           // tB[h
   TABLE4  = 'MOUSEPOS' ;  // }EX|C^f[^e[u
   TABLE4N = 4 ;           // tB[h
   TABLE5  = 'CADLIST' ;   // CAD}ʈꗗe[u
   TABLE5N = 22 ;          // tB[h
   TABLE6  = 'CADREV' ;    // ee[u
   TABLE6N = 5 ;           // tB[h
   TIMERWAIT1 = 5*1000 ;   // `bg@XV^C}[5b
   TIMERWAIT2 = 1*1000 ;   // }EX|C^ XV^C}[1b
   _LIMIT  = 0.00000001;
   _LIMITN = 0.0000000001;

var
   AppPath  : string ;  // vÔtH_@Ō͕Ku\v
   DBserv   : string ;  // T[o[iIPAhX{':'iu192.168.0.0:vj́ulocalhost:vj
   DBfold   : string ;  // T[o[̃f[^̃tH_@Ō͕Ku\vŏIĉBFuC:\data\v
   DBname   : string ;  // f[^x[Xigq́u.FDBvjtH_͕sv@FuPAINT.FDBv
   PCno     : integer ; // PCpҖ̔ԍ
   PCname   : string ;  // PCpҖ
   S_TYPE   : integer ; // P_TYPEւ̎󂯓np
   S_CODE1  : integer ; // P_CODE1ւ̎󂯓np
   S_CODE2  : integer ; // P_CODE2ւ̎󂯓np
   S_CODE3  : integer ; // P_CODE3ւ̎󂯓np
   S_CODEW1 : double ;
   S_CODEW2 : double ;
   Fm6_fl   : Boolean ; // Form6i`bgjʂ\Ă邩ǂidatۑȂj
   Fm6_w    : integer ; // Form6̕
   Fm6_h    : integer ; // Form6̍
   Fm8_fl   : Boolean ; // Form8i}EX|C^jʂ\Ă邩ǂidatۑȂj
   Fm12_w   : integer ; // Form12̕
   Fm12_h   : integer ; // Form12̍
   Fm13_w   : integer ; // Form13̕
   Fm13_h   : integer ; // Form13̍
   Fm12_c   : array[0..12] of integer ; // Form12SG1Z

   function ESCcheck : Boolean ;

   function SInt(s:string):integer ;
   function SFlo(s:string):single ;
   function SDbl(s:string):double ;
   function CheckNum(s:string):Boolean ;
   function MidStr2(S:string; V1,V2:integer;var V3:integer) : string ;
	function KLength(S:String): Integer ;
	function KMidStr(S:String; V1,V2:integer) : String ;
	function KTrim(S:String): String ;
   function QTrim(s:string):string ;
   function HanToZen(s:string):string ;
   function ZenToHan(s:string):string ;
   function GetStrCode(S:string) : String ;
   function GetStrName(S:string) : String ;
   function CheckDate(s:string) : Boolean ;
   function GetNetDrive(drv:string):string;

   function PaperSize(n:integer;var pax,pay:double):string;
	function  Roundoff(V:double) : double ;
	function IRoundoff(V:double) : Integer ;
   function ARoff(V,V1:double) : double ;
   function Roff(V:double) : double ;
   function ACos(V:double) : double ;
   function ASin(V:double) : double ;
   function PowN(V:double;V1:integer) : double ;
   function Dist(x1,y1,x2,y2:double):double ;
   function  Angle(dx,dy:double):double ;
   function dAngle(dx,dy:double):double ;
   procedure  Rev(var rx,ry:double;x,y,cx,cy,a:double) ;
   procedure dRev(var rx,ry:double;x,y,cx,cy,a:double) ;
   function   RevX(x,y,cx,cy,a:double):double ;
   function   RevY(x,y,cx,cy,a:double):double ;
   function  TextLen(s:string;w,d:double) : double ;

	procedure GCLS(C:TCanvas;x,y:Integer) ;
	procedure GPenSet(C:TCanvas; col,typ,wid:Integer) ;
	procedure GBrushSet(C:TCanvas;col,typ:Integer) ;
	procedure GCopyMode(C:TCanvas) ;
	procedure GXorMode(C:TCanvas) ;
	procedure GLine(C:TCanvas; x1,y1,x2,y2:Integer);
	procedure GBox (C:TCanvas; x1,y1,x2,y2:Integer);
   procedure GCircle(C:TCanvas; x,y,r:Integer);
   procedure GText(C:TCanvas; x,y,w,h,a,b,i:Integer;f,s:string);
	procedure GLLine(C:TCanvas; x1,y1,x2,y2:double;cl:TWinClip);
   procedure GLCircle(C:TCanvas; x,y,r:double;cl:TWinClip);
	procedure GLLineSub(C:TCanvas; x1,y1,x2,y2:double;cl:TWinClip;var at:TLineAtt);
   procedure GL_Line(C:TCanvas; x1,y1,x2,y2:double;cl:TWinClip;var at:TLineAtt);
   procedure GL_Circle(C:TCanvas; cx,cy,cr:double;cl:TWinClip;var at:TLineAtt);
   procedure GL_Arc(C:TCanvas; cx,cy,cr,sa,ea:double;cl:TWinClip;var at:TLineAtt);
   procedure GL_Text1(C:TCanvas; x,y,w,h,d,a:double;Fm,Ft:Integer;f,s:string;var at:TLineAtt;cl:TWinClip);
   procedure GL_Text2(C:TCanvas; x,y,w,h,d,a:double;Fm,Ft:Integer;f,s:string;var at:TLineAtt;cl:TWinClip);

implementation

function ESCcheck : Boolean ;
begin
   Result := False ;
   if ((GetAsyncKeyState(VK_ESCAPE)and $8000)>0) then
      Result := True ;
end;

// ---------- - ---------- - ----------
//       ֐E葱
//       Ƃ̕ϊ֐E葱
// ---------- - ---------- - ----------
// 񁨐
function SInt(s:string):integer ;
var
   a,i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0;
   end
   else
      a := 0;
   Result := a;
end;

// 񁨎(float(single))
function SFlo(s:string):single ;
var
   a : single ;
   i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then a := 0.0;
   end
   else
      a := 0.0;
   Result := a;
end;

// 񁨎(double)
function SDbl(s:string):double ;
var
   a : double ;
   i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0.0;
   end
   else
      a := 0.0;
   Result := a;
end;

// 񂪐ō\Ă邩`FbN
//    ̏ꍇ True ɂȂ
function CheckNum(s:string):Boolean ;
var
   i : integer ;
   ss: string ;
begin
   Result := True ;
   for i:=1 to Length(s) do begin
      ss := Copy(s,i,1);
      if (ss < '0')or(ss > '9') then begin
         Result := False ;
         break ;
      end;
   end;
end;

{ ̎wʒu炎oCgo܂
   in:S  ... ̕
     :V1 ... oJnʒu(1`)
     :V2 ... ooCg
 	out:V3 .. ۂɔooCg
   out: .... o
ŌA̕Ȃ悤ɒ }
function MidStr2(S:string; V1,V2:integer;var V3:integer) : string ;
var s1,s_1 : string ;
   i,l : integer ;
   f:Boolean;
begin
   l := Length(S) ;
   if (S = '')or(V1 < 1)or(V1 > l)or(V2 <= 0) then begin
       Result := '' ;
       V3 := 0;
       exit;
   end;
	s1:='';
   V3:=0;
	i:=1;
	f:=True;
	while(f)do begin
      s_1 := Copy(S,i,2) ;
		if (Ord(s_1[1]) >= 128)and(Ord(s_1[1]) <= 159)
       or(Ord(s_1[1]) >= 224)and(Ord(s_1[1]) <= 253) then begin
			if (i >= V1)and(i+1 <= V1+V2-1) then begin
         	// s1:=s1+S[i]+S[i+1];
            s1 := s1 + s_1 ;
         	V3:=V3+2;
         end;
			i:=i+2;
      end
      else begin
			if (i >= V1)and(i <= V1+V2-1) then begin
         	// s1:=s1+S[i];
            s1 := s1 + s_1[1] ;
         	Inc(V3);
         end;
			Inc(i);
      end;
		if (i > l) then f:=False;
   end;
   Result := s1 ;
end;

{BASICKLEN()Ɠl̊֐}
function KLength(S:String): Integer ;
var i,j,i1:Integer ;
   ss : string ;
begin
	j := 0 ;
	i := 1 ;
	i1 := Length(S) ;
	while(i <= i1) do begin
      ss := Copy(S,i,1);
		if (Ord(ss[1]) >= 128)and(Ord(ss[1]) <= 159)
       or(Ord(ss[1]) >= 224)and(Ord(ss[1]) <= 253) then
			Inc(i);
      Inc(i);
      Inc(j);
   end;
	Result := j ;
end;

{BASICKMID$()Ɠl̊֐}
{  in:S  ... ̕}
{    :V1 ... oJnʒu(1`)}
{    :V2 ... o}
{  out: .... o}
function KMidStr(S:String; V1,V2:integer) : String ;
var s1,s_1 : string ;
   i,j,i1,i2 : integer ;
	f : Boolean ;
begin
   s1 := '' ;
	i1 := KLength(S) ;
   if ((V1 > i1)or(V2 <= 0)or(i1 = 0)) then begin
       Result := s1 ;
       exit;
   end;
   i2 := V1 + V2 - 1 ;
   if (i2 > i1) then i2 := i1 ;
	i := 1 ;
	j := 1 ;
	while (j <= i2) do begin
		f := False ;
      s_1 := Copy(S,i,2);
		if (Ord(s_1[1]) >= 128)and(Ord(s_1[1]) <= 159)
       or(Ord(s_1[1]) >= 224)and(Ord(s_1[1]) <= 253) then
      	f := True ;
      if (j >= V1) then begin
			if (f) then
            s1 := s1 + s_1
         else
	         s1 := s1 + s_1[1] ;
      end;
      Inc(i);
		if (f) then Inc(i);
		Inc(j);
	end;
   Result := s1 ;
end;

{󔒁iSp^pj菜}
function KTrim(S:String): String ;
var i,i1:Integer ;
	r,t,s_1 : string ;
begin
	i1 := Length(S) ;
   if (i1 = 0) then begin
      Result := '' ;
      exit ;
   end;
	r := '' ;
	i := 1 ;
	while(i <= i1) do begin
      s_1 := Copy(S,i,2);
		if (Ord(s_1[1]) >= 128)and(Ord(s_1[1]) <= 159)
       or(Ord(s_1[1]) >= 224)and(Ord(s_1[1]) <= 253) then begin
      	// 
			t := s_1 ;
			if (t <> '@') then r := r + t ;
			i := i + 2 ;
		end
      else begin
      	// ANK
			t := s_1[1] ;
			if (t <> ' ')and(Ord(s_1[1]) >= 32) then r := r + t ;
	      Inc(i);
      end;
   end;
	Result := r ;
end;

// w蕶
//    PpEdpERg[R[h֐
function QTrim(S:String): String ;
var
   i,i1:Integer ;
	ss,r,t : string ;
begin
	r := '' ;
	i := 1 ;
	i1 := Length(S) ;
	while(i <= i1) do begin
      ss := Copy(S,i,2) ;
		if (Ord(ss[1]) >= 128)and(Ord(ss[1]) <= 159)
       or(Ord(ss[1]) >= 224)and(Ord(ss[1]) <= 253) then begin
			if ((i+1)<= i1) then begin
	      	// 
				t := ss ;
				r := r + t ;
				i := i + 2 ;
         end
         else
         	Inc(i);
		end
      else begin
      	// ANK
			t := ss[1] ;
			if (t <> '''')and(t <> '"')and(Ord(ss[1]) >= 32) then r := r + t ;
	      Inc(i);
      end;
   end;
	Result := r ;
end;

// pSp
//    p̍ő啶512܂
function HanToZen(s:string) : string ;
var
   Buf: array[0..1024] of Char;
   r  : string;
begin
   LCMapString(GetUserDefaultLCID,LCMAP_FULLWIDTH or LCMAP_KATAKANA,
      PChar(s), Length(s)+1, Buf, 1024);   // pSp,Ђ灨Ji
   r := string(Buf);
   Result := r;
end;

// Spp
//    Sp̍ő啶͈ꉞ512܂
function ZenToHan(s:string) : string ;
var
   Buf: array[0..1024] of Char;
   r  : string;
begin
   LCMapString(GetUserDefaultLCID,LCMAP_KATAKANA or LCMAP_HALFWIDTH,
      PChar(s), Length(s)+1, Buf, 1024);
   r := string(Buf);
   Result := r;
end;

// u:v`́̕A擾
function GetStrCode(S:string) : String ;
var
   i : Integer ;
begin
   Result := '' ;
   i := AnsiPos(':',S);
   if (i = 0)or(Length(S) = 0) then exit ;

   Result := Copy(S,1,i-1);
end;

// u:v`́̕A擾
function GetStrName(S:string) : String ;
var
   i : Integer ;
begin
   Result := '' ;
   i := AnsiPos(':',S);
   if (i = 0)or(Length(S) = 0) then exit ;

   Result := Copy(S,i+1,Length(S));
end;

// t̃`FbN
//    s : t@yyyymmdd`
// ret
//    True : OK  False : Error
function CheckDate(s:string) : Boolean ;
var
   dd: double ;
begin
   Result := False ;
   if (Length(s) <> 8) then exit ;
   if not(CheckNum(s)) then exit ;
   try
      dd := EncodeDate(SInt(Copy(s,1,4)),SInt(Copy(s,5,2)),SInt(Copy(s,7,2)));
   except
      exit ;
   end;
   if (dd < 0.0) then exit ;
   Result := True ;
end;

// hCů蓖ĂĂ鋤LfBNg擾
//		drv : zhCuiD:AH:AEEEj
//		ret : LfBNg
//				Ⴄꍇ́AhCû܂ܕԂ
function GetNetDrive(drv:string):string;
var
	ShareName: array[0..255] of Char ;
   Size: DWORD;
   s : string ;
begin
	Size := 256;
   if (WNetGetConnection(PChar(drv), ShareName, Size) = NO_ERROR) then
		s := string(ShareName)
   else
		s := drv ;
   Result := s ;
end;

// pTCY
//    n : 1`6:A0`A5@7`12:A0c`A5c
//    px,py : Ec̑傫[mm]
//    ret : uA0v`uA5cv
function PaperSize(n:integer;var pax,pay:double):string;
begin
   Result := 'C';
   pax := 100.0;
   pay := 100.0;
   Case(n)of
    1:   begin
				pax := 1189.0;
				pay :=  841.0;
            Result := 'A0';
         end;
    2:   begin
				pax := 841.0;
				pay := 594.0;
            Result := 'A1';
         end;
    3:   begin
				pax := 594.0;
				pay := 420.0;
            Result := 'A2';
         end;
    4:   begin
				pax := 420.0;
				pay := 297.0;
            Result := 'A3';
         end;
    5:   begin
				pax := 297.0;
				pay := 210.0;
            Result := 'A4';
         end;
    6:   begin
				pax := 210.0;
				pay := 148.0;
            Result := 'A5';
         end;
    7:   begin
				pax :=  841.0;
				pay := 1189.0;
            Result := 'A0c';
         end;
    8:   begin
				pax := 594.0;
				pay := 841.0;
            Result := 'A1c';
         end;
    9:   begin
				pax := 420.0;
				pay := 594.0;
            Result := 'A2c';
         end;
   10:   begin
				pax := 297.0;
				pay := 420.0;
            Result := 'A3c';
         end;
   11:   begin
				pax := 210.0;
				pay := 297.0;
            Result := 'A4c';
         end;
   12:   begin
				pax := 148.0;
				pay := 210.0;
            Result := 'A5c';
         end;
   end;
end;

{ ľܓ }
function Roundoff(V:double) : double ;
begin
	if (V >= 0) then
		Result := Trunc(V + 0.5)
	else
   	Result := Trunc(V - 0.5);
end;

{ ľܓ }
function IRoundoff(V:double) : Integer ;
begin
	if (V >= 0) then
		Result := Integer(Trunc(V + 0.5))
	else
   	Result := Integer(Trunc(V - 0.5));
end;

// ۂ
function ARoff(V,V1:double) : double ;
var
	r : double ;
begin
	r := Int(Abs(V)/V1 + 0.5)*V1 ;
   if (V < 0.0) then r := -r ;
	Result := r ;
end;

// 덷ۂ
//    _ȉ11Ŏľܓď_ȉ10ɂ
function Roff(V:double) : double ;
var
	r : double ;
begin
	r := Int(Abs(V)/_LIMITN + 0.5)*_LIMITN ;
   if (V < 0.0) then r := -r ;
	Result := r ;
end;

{A[NRTClit]j𓾂֐}
function ACos(V:double) : double ;
begin
   if (V < (-1.0+_LIMITN)) then
      V := -1.0
   else if (V > (1.0-_LIMITN)) then
      V := 1.0 ;

   try
      Result := ArcCos(V);
   except
      Result := 0.0;
   end;
end ;

{A[NTClitj𓾂֐}
function ASin(V:double) : double ;
begin
   if (V < (-1.0+_LIMITN)) then
      V := -1.0
   else if (V > (1.0-_LIMITN)) then
      V := 1.0 ;

   try
      Result := ArcSin(V);
   except
      Result := 0.0;
   end;
end ;

// ׂvZ
function PowN(V:double;V1:integer) : double ;
var
   x : double;
   i : integer;
begin
   x := 1.0;
   for i:=1 to V1 do begin
      x := x * V ;
   end;
   Result := x ;
end;

// ijvZ
//@@x1,y1 : n_
//@@x2,y2 : I_
//@@out : ()
function Dist(x1,y1,x2,y2:double):double ;
begin
	Result := Sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1)) ;
end;

// pxvZ[rad]
//@@dx : X
//@@dy : Y
//@@out: px (0`2*Pi)
function Angle(dx,dy:double):double ;
var
   r : double ;
begin
	Result := 0.0 ;
	if (Abs(dx) < _LIMITN)and(Abs(dy) < _LIMITN) then exit ;
	r := ArcTan2(dy,dx);
	if (r < 0.0) then r := r + 2.0 * Pi ;
   Result := r ;
end;

// pxvZ[]
//@@dx : X
//@@dy : Y
//@@out: px (0`360)
function dAngle(dx,dy:double):double ;
var
   r : double ;
begin
	r := Angle(dx,dy)*180.0/Pi ;
   Result := Roff(r) ;     // 덷ۂ߂ĕԂ
end;

// ][rad]
//    rx,ry : ]̍W
//    x ,y  : W
//    cx,cy : ]SW
//    a     : ]px[rad]
procedure Rev(var rx,ry:double;x,y,cx,cy,a:double) ;
begin
   rx := cx + (x-cx)*Cos(a) - (y-cy)*Sin(a) ;
   ry := cy + (x-cx)*Sin(a) + (y-cy)*Cos(a) ;
end;

// ][]
//    rx,ry : ]̍W
//    x ,y  : W
//    cx,cy : ]SW
//    a     : ]px[]
procedure dRev(var rx,ry:double;x,y,cx,cy,a:double) ;
var
   an : double ;  // WAl
begin
   an := a/180.0*Pi ;
   Rev(rx,ry, x,y,cx,cy,an) ;
end;

// ]x [rad]
//    x,y   :W
//    cx,cy :]SW
//    a     :]px[rad]
//    out   :]xW
//    ʏ́ARevAdRev 䗘p
function RevX(x,y,cx,cy,a:double):double ;
var
   w : double ;
begin
   w := cx + (x-cx)*Cos(a) - (y-cy)*Sin(a) ;
   Result := w ;
end;

// ]y [rad]
//    x,y   :W
//    cx,cy :]SW
//    a     :]px[rad]
//    out   :]yW
//    ʏ́ARevAdRev 䗘p
function RevY(x,y,cx,cy,a:double):double ;
var
   w : double ;
begin
   w := cy + (x-cx)*Sin(a) + (y-cy)*Cos(a) ;
   Result := w ;
end;

// Z
//    s : e
//    w : 
//    d : Ԋu
// (ret): 
function TextLen(s:string;w,d:double) : double ;
var
   i,i1:Integer ;
   r : double ;
   ss: string ;
begin
   r := 0.0;
	i := 1 ;
	i1 := Length(s) ;
	while(i <= i1) do begin
      ss := Copy(s,i,2) ;
		if (Ord(ss[1]) >= 128)and(Ord(ss[1]) <= 159)
       or(Ord(ss[1]) >= 224)and(Ord(ss[1]) <= 253) then begin
      	// 
         r := r + w ;
			i := i + 2 ;
         if (i <= i1) then r := r + d ;
		end
      else begin
      	// ANK
			if (Ord(ss[1]) >= 32) then r := r + w*0.5 ;
	      Inc(i);
         if (i <= i1) then r := r + d*0.5 ;
      end;
   end;
	Result := r ;
end;

// ---------- - ---------- - ----------
//       OtBbN֐E葱
// ---------- - ---------- - ----------

// ʃNAiwiFj
procedure GCLS(C:TCanvas;x,y:Integer) ;
begin
	with C do begin
      Pen.Mode    := pmCopy ;
      Pen.Width   := 1 ;
      Pen.Color	:= clWhite ;
  	   Brush.Color := clWhite ;
      Brush.Style := bsSolid ;
		Rectangle(0,0,x,y);
		Brush.Style := bsClear ;
	end;
end;

{ y̐ݒ
		col : F
		typ : No.
      wid : [dot] }
procedure GPenSet(C:TCanvas; col,typ,wid:Integer) ;
begin
	with C do begin
		Brush.Style := bsClear ;
		Pen.Color	:= col ;
		Pen.Width	:= wid ;
		Case (typ) of
		1 : Pen.Style := psDash	;
  		2 : Pen.Style := psDot ;
		3 : Pen.Style := psDashDot ;
		4 : Pen.Style := psDashDotDot ;
		5 : Pen.Style := psClear ;
		else
  	   	 Pen.Style := psSolid ;
		end;
	end;
end;

{ uV̐ݒ
		col : F
		typ : 0: 1:x^ 2: 3:
      		4:ΐ_ 5:ΐE^ 6:NX{ 7:NX~ }
procedure GBrushSet(C:TCanvas;col,typ:Integer) ;
begin
	with C.Brush do begin
		Color := col ;
		Case (typ) of
		1:	Style := bsSolid;			// ׂh
	   2:	Style := bsHorizontal;	// 
	   3:	Style := bsVertical;		// 
	   4:	Style := bsFDiagonal;	// ΐ	オ_
	   5:	Style := bsBDiagonal;	// ΐ@Eオ^
	   6:	Style := bsCross;			// NX
	   7:	Style := bsDiagCross;	// NXΐ
		else
      	Style := bsClear;			// 
		end;
   end;
end;

{ y}[hRs[[hɂ }
{		ʏ̊G }
procedure GCopyMode(C:TCanvas) ;
begin
	C.Pen.Mode := pmCopy ;
end;

{ y}[hXOR[hɂ }
{		o[{bNXQx`ď[h }
procedure GXorMode(C:TCanvas) ;
begin
	C.Pen.Mode := pmXor ;
end;

{ `
		x1,y1 : Jn_
		x2,y2 : I_ }
procedure GLine(C:TCanvas; x1,y1,x2,y2:Integer);
begin
	with C do begin
   	MoveTo(x1,y1);
     	LineTo(x2,y2);
   	Pixels[x2,y2] := Pen.Color ;
	end;
end;

{ ``
		x1,y1 : Jn_
		x2,y2 : I_ }
procedure GBox(C:TCanvas; x1,y1,x2,y2:Integer);
begin
	if (Abs(x1-x2) <= 2)and(Abs(y1-y2) <= 2) then exit ;
	if (Abs(x1-x2) <= 2) then begin
   	GLine(C,x1,y1,x1,y2);
   end
   else if (Abs(y1-y2) <= 2) then begin
   	GLine(C,x1,y1,x2,y1);
   end
   else begin
		with C do begin
   		Rectangle(x1,y1,x2,y2);
		end;
   end;
end;

{ ~`
		x,y : S_
		r   : a   }
procedure GCircle(C:TCanvas; x,y,r:Integer);
begin
	if (r <= 1) then begin
   	C.Pixels[x,y] := C.Pen.Color ;
      exit ;
   end;
	with C do begin
		Ellipse(x-r,y-r,x+r,y+r);
   end;
end;

{ `
      p͑Sp1/2ƂȂ
		x,y : E_
      w,h : (Sp),
      a   : px[](10{l)
      b   :  0:off 1:on
      i   : Α 0:off 1:on
      f   : tHg
		s   : e }
procedure GText(C:TCanvas; x,y,w,h,a,b,i:Integer;f,s:string);
var
   LogFont : TLogFont ;
begin
   with LogFont do begin
      lfHeight := h ;
      lfWidth  := w div 2 ;
      lfEscapement := a ;
      lfOrientation := 0 ;
      lfWeight := FW_NORMAL ; if (b <> 0) then lfWeight := FW_BOLD;
      lfItalic := 0 ;			if (i <> 0) then lfItalic := 1 ;
      lfUnderline := 0 ;
      lfStrikeOut := 0 ;
      lfCharSet        := DEFAULT_CHARSET ;
      lfOutPrecision   := OUT_DEFAULT_PRECIS ;
      lfClipPrecision  := CLIP_DEFAULT_PRECIS ;
      lfQuality        := DEFAULT_QUALITY ;
      lfPitchAndFamily := DEFAULT_PITCH ;
      StrPCopy(lfFaceName ,f);
   end;
   with C do begin
      Font.Handle := CreateFontIndirect(LogFont);
      Font.Color  := Pen.Color ;
      Brush.Style := bsClear ;
      TextOut(x,y,s);
   end;
end;

{ _Wɂ钼`
		x1,y1 : Jn_
		x2,y2 : I_ }
procedure GLLine(C:TCanvas; x1,y1,x2,y2:double;cl:TWinClip);
var
	i : integer ;
	ix1,iy1,ix2,iy2 : integer ;
	w1,w2 : double ;
begin
	i := ClipLine(x1,y1,x2,y2 , cl.lx1,cl.ly1,cl.lx2,cl.ly2) ;
	if (i = 2) then exit ;
	w1 := (x1 - cl.lx1)*cl.lsc ;
	w2 := (y1 - cl.ly1)*cl.lsc ;
   ix1 := IRoundoff(w1) ;
   iy1 := cl.phy - IRoundoff(w2) ;
   w1 := (x2 - cl.lx1)*cl.lsc ;
	w2 := (y2 - cl.ly1)*cl.lsc ;
   ix2 := IRoundoff(w1) ;
   iy2 := cl.phy - IRoundoff(w2) ;
	GLine(C, ix1,iy1,ix2,iy2);
end;

{ _Wɂ~`
		x,y : S_
		r   : a   }
procedure GLCircle(C:TCanvas; x,y,r:double;cl:TWinClip);
var
	i : integer ;
	ix,iy,ir : integer ;
	w1,w2 : double ;
begin
	i := Clip2Point(x-r,y-r,x+r,y+r , cl.lx1,cl.ly1,cl.lx2,cl.ly2) ;
	if (i = 2) then exit ;
	i := Clip2Point(x-r,y+r,x+r,y-r , cl.lx1,cl.ly1,cl.lx2,cl.ly2) ;
	if (i = 2) then exit ;

	w1 := (x - cl.lx1)*cl.lsc ;
	w2 := (y - cl.ly1)*cl.lsc ;
   ix := IRoundoff(w1) ;
   iy := cl.phy - IRoundoff(w2) ;
   ir := IRoundoff(r*cl.lsc);
	GCircle(C, ix,iy,ir);
end;

// sb`
// _Wɂ钼`iTupj
//		x1,y1 : Jn_
//		x2,y2 : I_
//    ̒sb`ꍇȂǂ̏
//    ł͍sȂ̂Ōďoōs
//    at̏ďoōs
procedure GLLineSub(C:TCanvas; x1,y1,x2,y2:double;cl:TWinClip;var at:TLineAtt);
var
   wd : integer ;
   w1 : double ;
   xx1,yy1,xx2,yy2,a,l,ll,ln : double ;
   sg : integer ;
   fl : Boolean ;
begin
   w1 := at.wid/100.0*cl.lsc ;
   if (w1 <=  0.0) then w1 :=   0.0 ;
   if (w1 > 400.0) then w1 := 400.0 ;
   wd := round(w1);
   GPenSet(C,at.col,0,wd);
   GBrushSet(C,at.col,0);

   if (at.pn <= 0)or(at.pn > 8) then begin
      GLLine(C,x1,y1,x2,y2,cl);
      exit ;
   end;

   sg := at.ppn ;
   ln := at.pln ;
	xx1:= x1 ;
   yy1:= y1 ;
	l  := Dist(x1,y1,x2,y2);
   a  := Angle(x2-x1,y2-y1);
	fl := True ;
   while(fl) do begin
		ll := Abs(at.pt[sg]) - ln ;
      if (ll > l) then ll := l ;

      xx2 := xx1 + ll*Cos(a) ;
      yy2 := yy1 + ll*Sin(a) ;
      if ((sg mod 2) = 0) then begin
         // ̏ꍇA}
         if (Abs(at.pt[sg]) < _LIMIT) then begin
            GPenSet(C,at.col,0,0);
            GBrushSet(C,at.col,1);
            GLCircle(C,xx1,yy1,at.wid/200.0,cl);
         end
         else begin
            GPenSet(C,at.col,0,wd);
            GBrushSet(C,at.col,0);
            GLLine(C,xx1,yy1,xx2,yy2,cl);
         end;
      end;
      xx1 := xx2 ;
      yy1 := yy2 ;

      l := l - ll ;
      if (l <= _LIMITN) then begin
      	fl := False ;
      	ln := ln + ll ;
      end
      else begin
      	ln := 0.0 ;
         Inc(sg);
         if (sg >= at.pn) then sg := 0;
      end;
   end;
   at.ppn := sg ;
   at.pln := ln ;
end;

// sb`
// _Wɂ钼`
//		x1,y1 : Jn_
//		x2,y2 : I_
procedure GL_Line(C:TCanvas; x1,y1,x2,y2:double;cl:TWinClip;var at:TLineAtt);
var
   l : double ;
begin
   at.ppn := 0 ;
   at.pln := 0.0;
   if (at.pn < 0)or(at.pn > 8) then at.pn := 0;
	l := Dist(x1,y1,x2,y2);
   if (l <= at.pit) then at.pn := 0;
   GLLineSub(C,x1,y1,x2,y2,cl,at);
end;

// sb`
// _Wɂ~`i72̓ڑp`Ƃĕ`j
//		cx,cy : S_
//		cr    : a
procedure GL_Circle(C:TCanvas; cx,cy,cr:double;cl:TWinClip;var at:TLineAtt);
var
	i : integer ;
	a1,a2 : double ;
   x1,y1,x2,y2 : double ;
   l : double ;
begin
   at.ppn := 0 ;
   at.pln := 0.0;
   if (at.pn < 0)or(at.pn > 8) then at.pn := 0;
   // SvZ
   l  := 0.0 ;
   x1 := 0.0 ;
   y1 := 0.0 ;
   a1 := 0.0 ;
  	a2 := 2.0 * Pi / 72.0 ;
   for i:=0 to 72 do begin
  	   x2 := cx + cr*Cos(a1);
     	y2 := cy + cr*Sin(a1);
   	a1 := a1 + a2 ;
      if (i > 0) then begin
         l := l + Dist(x1,y1,x2,y2);
      end;
      x1 := x2 ;
      y1 := y2 ;
	end;
   if (l <= at.pit) then at.pn := 0;
   // }
   a1 := 0.0 ;
   for i:=0 to 72 do begin
  	   x2 := cx + cr*Cos(a1);
     	y2 := cy + cr*Sin(a1);
   	a1 := a1 + a2 ;
      if (i > 0) then begin
         GLLineSub(C,x1,y1,x2,y2,cl,at);
      end;
      x1 := x2 ;
      y1 := y2 ;
	end;
end;

// sb`
// _Wɂ~ʕ`i72̓ڑp`Ƃĕ`j
//		cx,cy : S_
//		cr    : a
//    sa,ea : JnpxEIpx[]
procedure GL_Arc(C:TCanvas; cx,cy,cr,sa,ea:double;cl:TWinClip;var at:TLineAtt);
var
	i : integer ;
	da,a1,a2 : double ;
   x1,y1,x2,y2 : double ;
   l : double ;
begin
   at.ppn := 0 ;
   at.pln := 0.0;
   if (at.pn < 0)or(at.pn > 8) then at.pn := 0;
   while (sa <    0.0) do sa := sa + 360.0;
   while (sa >= 360.0) do sa := sa - 360.0;
   while (ea <    0.0) do ea := ea + 360.0;
   while (ea >= 360.0) do ea := ea - 360.0;
   da := ea - sa ;
   if (da < 0.0) then da := da + 360.0 ;
   if (Abs(da) < _LIMIT)or(Abs(da-360.0) < _LIMIT) then exit ;
   // SvZ
   l  := 0.0 ;
   x1 := 0.0 ;
   y1 := 0.0 ;
   a1 := sa/180.0*Pi ;
  	a2 := da/180.0*Pi / 72.0 ;
   for i:=0 to 72 do begin
  	   x2 := cx + cr*Cos(a1);
     	y2 := cy + cr*Sin(a1);
   	a1 := a1 + a2 ;
      if (i > 0) then begin
         l := l + Dist(x1,y1,x2,y2);
      end;
      x1 := x2 ;
      y1 := y2 ;
	end;
   if (l <= at.pit) then at.pn := 0;
   // }
   a1 := sa/180.0*Pi ;
   for i:=0 to 72 do begin
  	   x2 := cx + cr*Cos(a1);
     	y2 := cy + cr*Sin(a1);
   	a1 := a1 + a2 ;
      if (i > 0) then begin
         GLLineSub(C,x1,y1,x2,y2,cl,at);
      end;
      x1 := x2 ;
      y1 := y2 ;
	end;
end;

{ _Wɂ鉡`
      p͑Sp1/2ƂȂ
   	x,y: Wʒu[mm]
   	w	: iSpj
	   h  : 
      d  : ԊuiSp;p̌1/2j
      a  : px[]
   	Fm : ʒu킹[h
			6: 7: 8:E
			3: 4: 5:E
			0: 1: 2:E
   	Ft : bit1: bit2:Α bit3: bit4: bit5:
   	f	: tHg
   	s  :  }
procedure GL_Text1(C:TCanvas; x,y,w,h,d,a:double;Fm,Ft:Integer;f,s:string;var at:TLineAtt;cl:TWinClip);
var
	ih,iw,ia,ix,iy : integer ;
   LogFont : TLogFont ;
   i,j : integer ;
   ss: string ;
   an,wl,w1,w2,w3,w4,xx,yy: double ;
begin
	i := Length(s) ;
   if (i = 0) then exit ;

   C.Pen.Style := psSolid ;
   C.Pen.Color := at.col ;
	wl	:= TextLen(s,w,d);
   an := a/180.0*Pi ;
	// _ɍ킹
	Case(Fm)of
   1:	begin
   		w1 := - wl/2.0 ;
         w2 := h ;
   	end;
   2:	begin
   		w1 := - wl ;
         w2 := h ;
   	end;
	3:	begin
   		w1 := 0.0 ;
         w2 := h/2.0 ;
     	end;
   4:	begin
   		w1 := - wl/2.0 ;
         w2 := h/2.0 ;
     	end;
   5:	begin
   		w1 := - wl ;
         w2 := h/2.0 ;
     	end;
	6:	begin
   		w1 := 0.0 ;
         w2 := 0.0 ;
     	end;
   7:	begin
   		w1 := - wl/2.0 ;
         w2 := 0.0 ;
     	end;
   8:	begin
   		w1 := - wl ;
         w2 := 0.0 ;
     	end;
	else begin
   		w1 := 0.0 ;
         w2 := h ;
   	end;
	end;
   xx := x + RevX(w1,w2, 0.0,0.0,an);	// _
   yy := y + RevY(w1,w2, 0.0,0.0,an);
   // check
   if (Abs(h) < _LIMITN)or(Abs(h) *cl.lsc<6.0)
    or(Abs(wl)< _LIMITN)or(Abs(wl)*cl.lsc<6.0) then begin
		C.Pen.Width := 3 ;
      xx := xx + h*0.5 * Cos(an-Pi/2.0);
      yy := yy + h*0.5 * Sin(an-Pi/2.0);
      w3 := xx + wl * Cos(an);
      w4 := yy + wl * Sin(an);
      GLLine(C,xx,yy,w3,w4,cl);
		exit;
   end;
   if (Abs(h)*cl.lsc>1000.0)or(Abs(w)*cl.lsc>1000.0) then exit ;
   // font set
	ih := Round(Abs(h)*cl.lsc);
   iw := Round(Abs(w)*cl.lsc/2.0);
   ia := integer(Round(a*10.0)) ;
   with LogFont do begin
      lfHeight := ih ;
      lfWidth  := iw ;
      lfEscapement := ia ;
      lfOrientation := 0 ;
      lfWeight := FW_NORMAL ; if ((Ft and 1)>0) then lfWeight := FW_BOLD;
      lfItalic := 0 ;			if ((Ft and 2)>0) then lfItalic := 1 ;
      lfUnderline := 0 ;
      lfStrikeOut := 0 ;
      lfCharSet        := DEFAULT_CHARSET ;
      lfOutPrecision   := OUT_DEFAULT_PRECIS ;
      lfClipPrecision  := CLIP_DEFAULT_PRECIS ;
      lfQuality        := DEFAULT_QUALITY ;
      lfPitchAndFamily := DEFAULT_PITCH ;
      StrPCopy(lfFaceName ,f);
   end;
   with C do begin
      Font.Handle := CreateFontIndirect(LogFont);
      Font.Color  := Pen.Color ;
      Brush.Style := bsClear ;
   end;
   //
   for i:=1 to KLength(s) do begin
   	ss := KMidStr(s,i,1);
		if (Length(ss) = 1) then
         wl := w / 2.0
      else
         wl := w ;
      j := 0 ;
	   if (ClipPoint(xx,yy, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);
      w3 := xx + wl * Cos(an);
      w4 := yy + wl * Sin(an);
   	if (ClipPoint(w3,w4, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);
      w3 := w3 + h * Cos(an-Pi/2.0);
      w4 := w4 + h * Sin(an-Pi/2.0);
   	if (ClipPoint(w3,w4, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);
      w3 := xx + h * Cos(an-Pi/2.0);
      w4 := yy + h * Sin(an-Pi/2.0);
   	if (ClipPoint(w3,w4, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);
      w3 := xx + wl*0.5 * Cos(an) + h*0.5 * Cos(an-Pi/2.0);
      w4 := yy + wl*0.5 * Sin(an) + h*0.5 * Sin(an-Pi/2.0);
   	if (ClipPoint(w3,w4, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);

      if (j > 0)and(ss <> ' ')and(ss <> '@') then begin
      	w3 := (xx - cl.lx1)*cl.lsc ;
      	w4 := (yy - cl.ly1)*cl.lsc ;
         ix := IRoundoff(w3) ;
         iy := cl.phy - IRoundoff(w4) ;
         C.TextOut(ix,iy,ss);
      end;

		if (Length(ss) = 1) then
         wl := (w + d) / 2.0
      else
         wl := w + d ;
      xx := xx + wl * Cos(an);
      yy := yy + wl * Sin(an);
   end;

   C.Pen.Width	:= 0 ;
	wl	:= TextLen(s,w,d);
   // 
   if ((Ft and 4)>0) then begin
      xx := x + RevX(w1,w2, 0.0,0.0,an);	// _
      yy := y + RevY(w1,w2, 0.0,0.0,an);
      xx := xx + h * Cos(an-Pi/2.0);
      yy := yy + h * Sin(an-Pi/2.0);
      w3 := xx + wl * Cos(an);
      w4 := yy + wl * Sin(an);
      GLLine(C,xx,yy,w3,w4,cl);
   end;
   // 
   if ((Ft and 8)>0) then begin
      xx := x + RevX(w1,w2, 0.0,0.0,an);	// _
      yy := y + RevY(w1,w2, 0.0,0.0,an);
      xx := xx + h*0.5 * Cos(an-Pi/2.0);
      yy := yy + h*0.5 * Sin(an-Pi/2.0);
      w3 := xx + wl * Cos(an);
      w4 := yy + wl * Sin(an);
      GLLine(C,xx,yy,w3,w4,cl);
   end;
   // 
   if ((Ft and 16)>0) then begin
      xx := x + RevX(w1,w2, 0.0,0.0,an);	// _
      yy := y + RevY(w1,w2, 0.0,0.0,an);
      w3 := xx + wl * Cos(an);
      w4 := yy + wl * Sin(an);
      GLLine(C,xx,yy,w3,w4,cl);
   end;
end;

{ _Wɂc`
      p͑Sp1/2ƂȂ
   	x,y: Wʒu[mm]
   	w	: iSpj
	   h  : 
      d  : ԊuiSppj
      a  : px[]
   	Fm : ʒu킹[h
			6: 7: 8:E
			3: 4: 5:E
			0: 1: 2:E
   	Ft : bit1: bit2:Α bit3:() bit4: bit5:(E)
   	f	: tHg
   	s  :  }
procedure GL_Text2(C:TCanvas; x,y,w,h,d,a:double;Fm,Ft:Integer;f,s:string;var at:TLineAtt;cl:TWinClip);
var
	ih,iw,ia,ix,iy : integer ;
   LogFont : TLogFont ;
   i,j : integer ;
   ss: string ;
   an,wl,hl,w1,w2,w3,w4,xx,yy: double ;
begin
	i := KLength(s) ;
   if (i = 0) then exit ;

   C.Pen.Style := psSolid ;
   C.Pen.Color := at.col ;
   wl := w ;
	hl	:= i*h + (i-1)*d ;
   an := a/180.0*Pi ;
	// _ɍ킹
	Case(Fm)of
   1:	begin
   		w1 := - wl/2.0 ;
         w2 := hl ;
   	end;
   2:	begin
   		w1 := - wl ;
         w2 := hl ;
   	end;
	3:	begin
   		w1 := 0.0 ;
         w2 := hl/2.0 ;
     	end;
   4:	begin
   		w1 := - wl/2.0 ;
         w2 := hl/2.0 ;
     	end;
   5:	begin
   		w1 := - wl ;
         w2 := hl/2.0 ;
     	end;
	6:	begin
   		w1 := 0.0 ;
         w2 := 0.0 ;
     	end;
   7:	begin
   		w1 := - wl/2.0 ;
         w2 := 0.0 ;
     	end;
   8:	begin
   		w1 := - wl ;
         w2 := 0.0 ;
     	end;
	else begin
   		w1 := 0.0 ;
         w2 := hl ;
   	end;
	end;
   xx := x + RevX(w1,w2, 0.0,0.0,an);	// _
   yy := y + RevY(w1,w2, 0.0,0.0,an);
   // check
   if (Abs(hl)< _LIMITN)or(Abs(hl)*cl.lsc<6.0)
    or(Abs(wl)< _LIMITN)or(Abs(wl)*cl.lsc<6.0) then begin
		C.Pen.Width := 3 ;
      xx := xx + wl*0.5 * Cos(an);
      yy := yy + wl*0.5 * Sin(an);
      w3 := xx + hl * Cos(an-Pi/2.0);
      w4 := yy + hl * Sin(an-Pi/2.0);
      GLLine(C,xx,yy,w3,w4,cl);
		exit;
   end;
   if (Abs(h)*cl.lsc>1000.0)or(Abs(w)*cl.lsc>1000.0) then exit ;
   // font set
	ih := Round(Abs(h)*cl.lsc);
   iw := Round(Abs(w)*cl.lsc/2.0);
   ia := integer(Round(a*10.0)) ;
   with LogFont do begin
      lfHeight := ih ;
      lfWidth  := iw ;
      lfEscapement := ia ;
      lfOrientation := 0 ;
      lfWeight := FW_NORMAL ; if ((Ft and 1)>0) then lfWeight := FW_BOLD;
      lfItalic := 0 ;			if ((Ft and 2)>0) then lfItalic := 1 ;
      lfUnderline := 0 ;
      lfStrikeOut := 0 ;
      lfCharSet        := DEFAULT_CHARSET ;
      lfOutPrecision   := OUT_DEFAULT_PRECIS ;
      lfClipPrecision  := CLIP_DEFAULT_PRECIS ;
      lfQuality        := DEFAULT_QUALITY ;
      lfPitchAndFamily := DEFAULT_PITCH ;
      StrPCopy(lfFaceName ,f);
   end;
   with C do begin
      Font.Handle := CreateFontIndirect(LogFont);
      Font.Color  := Pen.Color ;
      Brush.Style := bsClear ;
   end;
   //
   for i:=1 to KLength(s) do begin
   	ss := KMidStr(s,i,1);

      j := 0 ;
	   if (ClipPoint(xx,yy, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);
      w3 := xx + w * Cos(an);
      w4 := yy + w * Sin(an);
   	if (ClipPoint(w3,w4, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);
      w3 := w3 + h * Cos(an-Pi/2.0);
      w4 := w4 + h * Sin(an-Pi/2.0);
   	if (ClipPoint(w3,w4, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);
      w3 := xx + h * Cos(an-Pi/2.0);
      w4 := yy + h * Sin(an-Pi/2.0);
   	if (ClipPoint(w3,w4, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);
      w3 := xx + w*0.5 * Cos(an) + h*0.5 * Cos(an-Pi/2.0);
      w4 := yy + w*0.5 * Sin(an) + h*0.5 * Sin(an-Pi/2.0);
   	if (ClipPoint(w3,w4, cl.lx1,cl.ly1,cl.lx2,cl.ly2) = 0) then Inc(j);

      if (j > 0)and(ss <> ' ')and(ss <> '@') then begin
         w3 := xx ;
         w4 := yy ;
   		if (Length(ss) = 1) then begin
            w3 := xx + w*0.25 * Cos(an);
            w4 := yy + w*0.25 * Sin(an);
         end;
      	w3 := (w3 - cl.lx1)*cl.lsc ;
      	w4 := (w4 - cl.ly1)*cl.lsc ;
         ix := IRoundoff(w3) ;
         iy := cl.phy - IRoundoff(w4) ;
         C.TextOut(ix,iy,ss);
      end;

      xx := xx + (h + d) * Cos(an-Pi/2.0);
      yy := yy + (h + d) * Sin(an-Pi/2.0);
   end;

   C.Pen.Width	:= 0 ;
   // ij
   if ((Ft and 4)>0) then begin
      xx := x + RevX(w1,w2, 0.0,0.0,an);	// _
      yy := y + RevY(w1,w2, 0.0,0.0,an);
      w3 := xx + hl * Cos(an-Pi/2.0);
      w4 := yy + hl * Sin(an-Pi/2.0);
      GLLine(C,xx,yy,w3,w4,cl);
   end;
   // 
   if ((Ft and 8)>0) then begin
      xx := x + RevX(w1,w2, 0.0,0.0,an);	// _
      yy := y + RevY(w1,w2, 0.0,0.0,an);
      xx := xx + wl*0.5 * Cos(an);
      yy := yy + wl*0.5 * Sin(an);
      w3 := xx + hl * Cos(an-Pi/2.0);
      w4 := yy + hl * Sin(an-Pi/2.0);
      GLLine(C,xx,yy,w3,w4,cl);
   end;
   // iEj
   if ((Ft and 16)>0) then begin
      xx := x + RevX(w1,w2, 0.0,0.0,an);	// _
      yy := y + RevY(w1,w2, 0.0,0.0,an);
      xx := xx + wl * Cos(an);
      yy := yy + wl * Sin(an);
      w3 := xx + hl * Cos(an-Pi/2.0);
      w4 := yy + hl * Sin(an-Pi/2.0);
      GLLine(C,xx,yy,w3,w4,cl);
   end;
end;

end.
