unit Unit13;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  UnitV, Menus, ExtCtrls ;

type
  TForm13 = class(TForm)
    MainMenu1: TMainMenu;
    mnuChat: TMenuItem;
    mnuChatStart: TMenuItem;
    mnuChatEdit: TMenuItem;
    MnuDmy4: TMenuItem;
    mnuMousePointer: TMenuItem;
    mnuCad: TMenuItem;
    mnuCadNew: TMenuItem;
    mnuCadEdit: TMenuItem;
    mnuCadList: TMenuItem;
    PaintBox1: TPaintBox;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuChatStartClick(Sender: TObject);
    procedure mnuChatEditClick(Sender: TObject);
    procedure mnuMousePointerClick(Sender: TObject);
    procedure mnuCadNewClick(Sender: TObject);
    procedure mnuCadEditClick(Sender: TObject);
    procedure mnuCadListClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    FirstDrawFlag : Boolean ;    // ŏɉʂ`悵
	 mwheel1 : integer ;          // }EXzC[ 0:{ 1:|
    mwheel2 : double ;           // }EXzC[g嗦
    MouseBtnState : integer ;				// }EX{^ 1:Left 2:Right 4:Middle 8:DoubleClick 16:Shift 32:Alt 64:Ctrl
	 MouseBtnX, MouseBtnY : integer ;	// }EXNbN̍W
    DrawRB1 : Boolean ;          // {^hbOۂ
    DrawRBx1,DrawRBy1,DrawRBx2,DrawRBy2 : integer ;
    RepBmp : TBitmap ;           // ʍĕ`p
    WrkBmp : TBitmap ;           // }EX{^hbOړp
    WrkBmpFlag : Boolean ;

    LogicWx1,LogicWy1,LogicWx2,LogicWy2 : double ;	      // ʃEChE
    LogicScale : double ;	      // 1mm̃hbg
 	 Phsx,Phsy : Integer ;	      // ʃhbgTCY
  	 MinWx,MinWy,MaxWx,MaxWy : double ;
    BLogicWx1,BLogicWy1,BLogicWx2,BLogicWy2 : double ;   // Backup
    BLogicScale : double ;	      // Backup

    MouseWheelFlag : Boolean ;   // ʕ`̍ۂ̒f`FbNp
    MouseWheelCheck: Boolean ;
    MouseWheelStop : integer ;   // iniݒp

    procedure dispRBBox ;
    procedure dispDrawFirst ;
    procedure dispMouseWheel(mx,my:integer; r:double);
    procedure dispDrawAll ;
	 procedure dispZoom(x1,y1,x2,y2:double) ;
	 procedure dispZoomDown(x1,y1,x2,y2:double) ;
	 procedure dispMove(x1,y1:double) ;  public
    { Public 錾 }
    P_CODE1 : integer ;    // CADꗗf[^o^ԍ
    P_PAPX , P_PAPY : double ;   // pTCY
  end;

var
  Form13: TForm13;

implementation

uses
   Unit1 ;

{$R *.dfm}

// J
procedure TForm13.FormShow(Sender: TObject);
begin
   P_CODE1:= S_CODE1;   // [h󂯓n
   P_PAPX := S_CODEW1;
   P_PAPY := S_CODEW2;

   Width  := Fm13_w ;
   Height := Fm13_h ;

   FirstDrawFlag := False ;
   MouseWheelCheck := False ;
   MouseWheelFlag  := False ;
   MouseWheelStop  := 0 ;
	mwheel1 := 0 ;
	mwheel2 := 1.5 ;
   MouseBtnState := 0;
	MouseBtnX := 0 ;
  	MouseBtnY := 0 ;
	DrawRB1	:= False ;
   RepBmp := nil ;
	WrkBmp := nil ;
   WrkBmpFlag := False ;

   dispDrawFirst ;
   FirstDrawFlag := True ;
end;

// 
procedure TForm13.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Fm13_w := Width ;
   Fm13_h := Height ;

   if (RepBmp <> nil) then begin
      RepBmp.Free;
      RepBmp := nil;
   end;
   if (WrkBmp <> nil) then begin
      WrkBmp.Free;
      WrkBmp := nil;
   end;

   Action := caFree ;
end;

// j[(Form1)b`bgJn
procedure TForm13.mnuChatStartClick(Sender: TObject);
begin
   Form1.G_mnuChatStartClick(Sender);
end;

// j[(Form1)b`bge̕ҏW
procedure TForm13.mnuChatEditClick(Sender: TObject);
begin
   Form1.G_mnuChatEditClick(Sender);
end;

// j[(Form1)b}EX|C^
procedure TForm13.mnuMousePointerClick(Sender: TObject);
begin
   Form1.G_mnuMousePointerClick(Sender);
end;

// j[(Form1)bCAD}ʁbVK쐬
procedure TForm13.mnuCadNewClick(Sender: TObject);
begin
   Form1.G_mnuCadNewClick(Sender);
end;

// j[(Form1)bCAD}ʁbҏW
procedure TForm13.mnuCadEditClick(Sender: TObject);
begin
   Form1.G_mnuCadEditClick(Sender);
end;

// j[(Form1)bCAD}ʁbꗗ\
procedure TForm13.mnuCadListClick(Sender: TObject);
begin
   Form1.G_mnuCadListClick(Sender);
end;

// ʃTCY
procedure TForm13.FormResize(Sender: TObject);
var
   w1,w2 : double ;
begin
   if (FirstDrawFlag) then begin
   	Phsx := PaintBox1.Width ;
      Phsy := PaintBox1.Height ;
      w1 := (LogicWx1 + LogicWx2)/2.0 ;
      w2 := (LogicWy1 + LogicWy2)/2.0 ;
      LogicWx1 := w1 - Phsx/2.0/LogicScale ;
      LogicWy1 := w2 - Phsy/2.0/LogicScale ;
      LogicWx2 := w1 + Phsx/2.0/LogicScale ;
      LogicWy2 := w2 + Phsy/2.0/LogicScale ;
   end;
end;

// ʍĕ`
procedure TForm13.PaintBox1Paint(Sender: TObject);
begin
   if (MouseWheelCheck) then exit ;

   DrawRB1:= False ;
	if (RepBmp = nil) then
      dispDrawFirst
   else begin
   	with PaintBox1 do begin
   		GCLS(Canvas,Width,Height);
   		GPenSet(Canvas,clBlue,0,0);
   		GBox(Canvas,0,0,Width-1,Height-1);
   		PaintBox1.Canvas.Draw(0,0,RepBmp);
      end;
   end;
end;

// L[
procedure TForm13.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   x1,y1,x2,y2,mx,my : integer ;
	r : double ;
   x,y : integer ;
	wx,wy : double ;
begin
   if (MouseWheelCheck) then exit ;

	if (Key = VK_PRIOR) then begin
		// PageUp
		r := mwheel2 ;
   	if (mwheel1 <> 0) then r := 1.0/mwheel2 ;
      x := ClientOrigin.x + PaintBox1.Left + PaintBox1.Width  div 2 ;
      y := ClientOrigin.y + PaintBox1.Top  + PaintBox1.Height div 2 ;
		dispMouseWheel(x,y,r);
	   Key := 0 ;
   end
   else if (Key = VK_NEXT) then begin
		// PageDown
		r := 1.0/mwheel2 ;
	   if (mwheel1 <> 0) then r := mwheel2 ;
      x := ClientOrigin.x + PaintBox1.Left + PaintBox1.Width  div 2 ;
      y := ClientOrigin.y + PaintBox1.Top  + PaintBox1.Height div 2 ;
		dispMouseWheel(x,y,r);
	   Key := 0 ;
	end
   else if (Key = VK_INSERT)or(Key = VK_END) then begin
		// ړ
      BLogicScale := LogicScale ;
      BLogicWx1 := LogicWx1 ;
      BLogicWy1 := LogicWy1 ;
      BLogicWx2 := LogicWx2 ;
      BLogicWy2 := LogicWy2 ;
	   wx := (MaxWx + MinWx)/2.0;
   	wy := (MaxWy + MinWy)/2.0;
		LogicWx1 := wx - Phsx/2.0/LogicScale ;
	  	LogicWy1 := wy - Phsy/2.0/LogicScale ;
	   LogicWx2 := wx + Phsx/2.0/LogicScale ;
	  	LogicWy2 := wy + Phsy/2.0/LogicScale ;
	   dispDrawAll ;
	   Key := 0 ;
	end
   else if (Key = VK_HOME) then begin
		// S
		dispDrawFirst;
	   Key := 0 ;
	end
   else if (Key = VK_LEFT)or(Key = VK_RIGHT)or(Key = VK_UP)or(Key = VK_DOWN) then begin
      x1 := ClientOrigin.x + PaintBox1.Left ;
      y1 := ClientOrigin.y + PaintBox1.Top  ;
      x2 := x1 + PaintBox1.Width ;
      y2 := y1 + PaintBox1.Height ;
      mx := Mouse.CursorPos.X ;
      my := Mouse.CursorPos.Y ;
      if (mx < x1)or(mx > x2)
       or(my < y1)or(my > y2) then begin
   	   Key := 0 ;
         exit;
      end;
      BLogicScale := LogicScale ;
      BLogicWx1 := LogicWx1 ;
      BLogicWy1 := LogicWy1 ;
      BLogicWx2 := LogicWx2 ;
      BLogicWy2 := LogicWy2 ;
		wx := Abs(LogicWx2 - LogicWx1)/2.0 ;
		wy := Abs(LogicWy2 - LogicWy1)/2.0 ;
	   if ssShift in Shift then begin
			wx := wx/5.0 ;
			wy := wy/5.0 ;
      end;
	   if (Key = VK_LEFT) then begin
			LogicWx1 := LogicWx1 - wx ;
	   	LogicWx2 := LogicWx2 - wx ;
		end
   	else if (Key = VK_RIGHT) then begin
			LogicWx1 := LogicWx1 + wx ;
	   	LogicWx2 := LogicWx2 + wx ;
		end
   	else if (Key = VK_UP) then begin
			LogicWy1 := LogicWy1 + wy ;
	   	LogicWy2 := LogicWy2 + wy ;
		end
   	else begin
			LogicWy1 := LogicWy1 - wy ;
	   	LogicWy2 := LogicWy2 - wy ;
      end;
	   dispDrawAll ;
	   Key := 0 ;
   end
   else if (Key = VK_ESCAPE) then begin
      Key := 0 ;
   end;
end;

// }EXzC[
procedure TForm13.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
	r : double ;
begin
   if (MouseWheelCheck) then begin
      if (MouseWheelStop <> 0) then
         MouseWheelFlag := True ;
      exit ;
   end;
   Handled := False ;
   r := mwheel2 ;
   if (mwheel1 <> 0) then
   	r := 1.0/mwheel2 ;
   dispMouseWheel(MousePos.x,MousePos.y,r);
   Handled := True ;
end;

// }EXzC[
procedure TForm13.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
	r : double ;
begin
   if (MouseWheelCheck) then begin
      if (MouseWheelStop <> 0) then
         MouseWheelFlag := True ;
      exit ;
   end;
   Handled := False ;
	r := 1.0/mwheel2 ;
   if (mwheel1 <> 0) then
   	r := mwheel2 ;
   dispMouseWheel(MousePos.x,MousePos.y,r);
   Handled := True ;
end;

// [}EX̏]
procedure TForm13.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (MouseWheelCheck) then exit ;

	if ((MouseBtnState and 3) = 0) then begin
		MouseBtnX := X ;
   	MouseBtnY := Y ;
	end;

   if ssLeft in Shift then		// {^
		MouseBtnState := MouseBtnState or 1 ;
   if ssRight in Shift then	// E{^
		MouseBtnState := MouseBtnState or 2 ;
   if ssMiddle in Shift then	// {^
		MouseBtnState := MouseBtnState or 4 ;
   if ssDouble in Shift then	// _uNbN
		MouseBtnState := MouseBtnState or 8 ;

   if ssShift in Shift then	// Shift L[
		MouseBtnState := MouseBtnState or 16 ;
   if ssAlt in Shift then		// Alt L[
		MouseBtnState := MouseBtnState or 32 ;
   if ssCtrl in Shift then		// Ctrl L[
		MouseBtnState := MouseBtnState or 64 ;

	if ((MouseBtnState and 4) > 0) then begin
		if (WrkBmpFlag) then begin
		   WrkBmpFlag := False ;
     		WrkBmp.Free ;
        	WrkBmp := nil ;
      end;
      try
	      WrkBmp := TBitmap.Create ;
			WrkBmp.Width := PaintBox1.Width ;
         WrkBmp.Height:= PaintBox1.Height ;
         BitBlt(WrkBmp.Canvas.Handle,0,0,WrkBmp.Width,WrkBmp.Height,PaintBox1.Canvas.Handle,0,0,SRCCOPY);
			WrkBmpFlag := True ;
		except
		   WrkBmpFlag := False ;
      	WrkBmp.Free ;
        	WrkBmp := nil ;
      end;
   end;
end;

// [}EXړ^hbO]
procedure TForm13.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
	xx,yy : integer ;
//	x1,y1,x2,y2,w : double ;
begin
   if (MouseWheelCheck) then exit ;
   // x1 := LogicWx1 + X / LogicScale ;
   // y1 := LogicWy2 - Y / LogicScale ;
   //	x2 := Int(Abs(x1)*1000.0+0.5)/1000.0;	if (x1 < 0.0) then x2 := -x2;
   //	y2 := Int(Abs(y1)*1000.0+0.5)/1000.0;	if (y1 < 0.0) then y2 := -y2;
   // w  := Int(Phsx/LogicScale*1000.0+0.5)/1000.0; ;
   // EditA.SetFocus ;

	if ((MouseBtnState and 3) = 3) then begin
		// {^hbO
		if (DrawRB1) then dispRBBox ;
      DrawRBx1 := MouseBtnX ;
  	   DrawRBy1 := MouseBtnY ;
      DrawRBx2 := X ;
  	   DrawRBy2 := Y ;
     	dispRBBox ;
		DrawRB1 := True ;
	end
	else if ((MouseBtnState and 4) > 0) then begin
		xx := X - MouseBtnX ;
      yy := Y - MouseBtnY ;
		if (WrkBmpFlag) then begin
   		DrawRB1:= False ;
			GCLS(PaintBox1.Canvas,PaintBox1.Width,PaintBox1.Height);
			PaintBox1.Canvas.Draw(xx,yy,WrkBmp);
      end;
	end
   else if ((MouseBtnState and 1) = 1) then begin
		// }EXړ
	end;
end;

// [}EX𗣂̏]
procedure TForm13.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
	x1,y1,x2,y2 : double ;
   w0,w1,w2,w3,w4 : double ;
begin
   if (MouseWheelCheck) then exit ;

   x1 := LogicWx1 + MouseBtnX / LogicScale ;
   y1 := LogicWy2 - MouseBtnY / LogicScale ;
   x2 := LogicWx1 + X / LogicScale ;
   y2 := LogicWy2 - Y / LogicScale ;

	if ((MouseBtnState and 3) = 3) then begin
		// {^hbO
		if (DrawRB1) then dispRBBox ;
      DrawRB1 := False ;
		if (Abs(x2-x1) <= (5.0/LogicScale))
       or(Abs(y2-y1) <= (5.0/LogicScale)) then begin
     	   dispMove(x1,y1);	         // ړ
		end
      else if(x1 < x2)and(y1 > y2) then begin
         dispZoom(x1,y1,x2,y2);	   // g
      end
      else if(x1 > x2)and(y1 < y2) then begin
         dispZoomDown(x1,y1,x2,y2);	// k
      end
      else if(x1 < x2)and(y1 < y2) then begin
			dispDrawFirst ;
		end
      else begin
         w0 := LogicScale ;
         w1 := LogicWx1 ;
         w2 := LogicWy1 ;
         w3 := LogicWx2 ;
         w4 := LogicWy2 ;
         LogicScale := BLogicScale ;
         LogicWx1   := BLogicWx1 ;
         LogicWy1   := BLogicWy1 ;
         LogicWx2   := BLogicWx2 ;
         LogicWy2   := BLogicWy2 ;
   		dispDrawAll ;
         BLogicScale := w0 ;
         BLogicWx1 := w1 ;
         BLogicWy1 := w2 ;
         BLogicWx2 := w3 ;
         BLogicWy2 := w4 ;
		end;
	end
	else if ((MouseBtnState and 4) > 0) then begin
		if (WrkBmpFlag) then begin
      	WrkBmp.Free ;
			WrkBmp := nil ;
         WrkBmpFlag := False ;
		end;
      BLogicScale := LogicScale ;
      BLogicWx1 := LogicWx1 ;
      BLogicWy1 := LogicWy1 ;
      BLogicWx2 := LogicWx2 ;
      BLogicWy2 := LogicWy2 ;

	   LogicWx1 := LogicWx1 + (x1-x2) ;
   	LogicWy1 := LogicWy1 + (y1-y2) ;
	   LogicWx2 := LogicWx2 + (x1-x2) ;
   	LogicWy2 := LogicWy2 + (y1-y2) ;
  	   dispDrawAll;      // hbOړ
	end
	else if ((MouseBtnState and 1) = 1) then begin
      // }EXʏ푀
   end;
   MouseBtnState := 0 ;
end;



// `o[oh\
//		`\
procedure TForm13.dispRBBox ;
begin
   with PaintBox1 do begin
   	GXorMode(Canvas);
	   GPenSet(Canvas,clAqua,0,3);
   	GBrushSet(Canvas,0,0);
	   GBox(Canvas,DrawRBx1,DrawRBy1,DrawRBx2,DrawRBy2);
   end;
end;

// ʕ\
procedure TForm13.dispDrawFirst ;
var
   w1,w2,w3,w4 : double ;
begin
   BLogicScale := LogicScale ;
   BLogicWx1 := LogicWx1 ;
   BLogicWy1 := LogicWy1 ;
   BLogicWx2 := LogicWx2 ;
   BLogicWy2 := LogicWy2 ;

	Phsx := PaintBox1.Width ;		// ʃTCY
   Phsy := PaintBox1.Height ;
   // }`f[^̍ŏőW擾
   // ݂͗pTCYɂĂ
   MinWx := - P_PAPX/2.0;
   MinWy := - P_PAPY/2.0;
   MaxWx :=   P_PAPX/2.0;
   MaxWy :=   P_PAPY/2.0;

   w1 := Abs(MaxWx - MinWx);
   w2 := Abs(MaxWy - MinWy);
	if (w1 <= _LIMITN) then w1 := _LIMITN ;
	if (w2 <= _LIMITN) then w2 := _LIMITN ;
   w3 := Phsx / w1 * 0.9 ;
   w4 := Phsy / w2 * 0.9 ;
   if (w3 < w4) then
      LogicScale := w3
   else
   	LogicScale := w4 ;
   w3 := (MaxWx + MinWx)/2.0 ;
   w4 := (MaxWy + MinWy)/2.0 ;
   LogicWx1 := w3 - Phsx/2.0/LogicScale ;
   LogicWy1 := w4 - Phsy/2.0/LogicScale ;
   LogicWx2 := w3 + Phsx/2.0/LogicScale ;
   LogicWy2 := w4 + Phsy/2.0/LogicScale ;
   dispDrawAll ;
end;

// }EXzC[ɂʊgk\
procedure TForm13.dispMouseWheel(mx,my:integer; r:double);
var
	ix,iy : integer ;
	cx,cy , wx,wy , x,y : double ;
begin
   BLogicScale := LogicScale ;
   BLogicWx1 := LogicWx1 ;
   BLogicWy1 := LogicWy1 ;
   BLogicWx2 := LogicWx2 ;
   BLogicWy2 := LogicWy2 ;

   ix:= mx - ClientOrigin.x - PaintBox1.Left;
   iy:= my - ClientOrigin.y - PaintBox1.Top ;
   x := LogicWx1 + ix / LogicScale ;
   y := LogicWy2 - iy / LogicScale ;
	cx := (LogicWx1 + LogicWx2)/2.0 ;
   cy := (LogicWy1 + LogicWy2)/2.0 ;

	LogicScale := LogicScale * r ;
	wx := (LogicWx2 - LogicWx1)/2.0/r ;
   wy := (LogicWy2 - LogicWy1)/2.0/r ;
	LogicWx1 := cx - wx - (x - cx)/r + (x - cx) ;
  	LogicWy1 := cy - wy - (y - cy)/r + (y - cy) ;
   LogicWx2 := cx + wx - (x - cx)/r + (x - cx) ;
  	LogicWy2 := cy + wy - (y - cy)/r + (y - cy) ;
   dispDrawAll ;
end;

// ʕ\
procedure TForm13.dispDrawAll ;
var
   w1,w2 : double ;
   cl : TWinClip ;
   at : TLineAtt ;
   i  : integer ;
begin
   if not(FirstDrawFlag) then exit;
   DrawRB1 := False ;
   MouseWheelCheck := True ;
   if (MouseWheelStop = 0) then MouseWheelCheck := False ;
   MouseWheelFlag  := False ;

	with PaintBox1 do begin
		GCLS(Canvas,Width,Height);
		GPenSet(Canvas,clAqua,0,0);
		GBox(Canvas,0,0,Width-1,Height-1);

      // p
      GPenSet(Canvas,clBlack,0,3) ;
      w1 := P_PAPX/2.0 ;
      w2 := P_PAPY/2.0 ;
      cl.lsc := LogicScale ;
      cl.lx1 := LogicWx1 ;
      cl.ly1 := LogicWy1 ;
      cl.lx2 := LogicWx2 ;
      cl.ly2 := LogicWy2 ;
      cl.phx := Phsx ;
      cl.phy := Phsy ;
      GLLine(Canvas,-w1,-w2 , w1,-w2 , cl);
      GLLine(Canvas, w1,-w2 , w1, w2 , cl) ;
      GLLine(Canvas, w1, w2 ,-w1, w2 , cl) ;
      GLLine(Canvas,-w1, w2 ,-w1,-w2 , cl) ;

      // _
      GPenSet(Canvas,clRed,0,1) ;
      w1 := 5/LogicScale ;
      GLLine(Canvas,-w1,0.0 , w1,0.0 , cl);
      GLLine(Canvas, 0.0,-w1, 0.0,w1 , cl) ;

      // }`f[^}
      // eXg
      w1 := P_PAPX/2.0 ;
      w2 := P_PAPY/2.0 ;
      at.col := clBlue ;
      at.wid := 100 ;
      at.pit := 0.0 ;
      at.pn  := 0 ;
      for i:=0 to 7 do
         at.pt[i] := 0.0 ;
      GL_Line(Canvas, -w1,-w2, w1,w2, cl, at);
      at.col := clRed ;
      at.wid := 150 ;
      at.pn  := 2 ;
      at.pt[0] := 10.0 ;
      at.pt[1] :=  5.0 ;
      at.pit := 0.0 ;
      for i:=0 to at.pn-1 do
         at.pit := at.pit + at.pt[i] ;
      GL_Line(Canvas, -w1,w2, w1,-w2, cl, at);

      at.col := clBlack ;
      at.wid := 200 ;
      at.pn  := 4 ;
      at.pt[0] := 10.0 ;
      at.pt[1] :=  5.0 ;
      at.pt[2] :=  0.0 ;
      at.pt[3] :=  5.0 ;
      at.pit := 0.0 ;
      for i:=0 to at.pn-1 do
         at.pit := at.pit + at.pt[i] ;
      GL_Circle(Canvas, 0,0,100, cl, at);

      at.col := clLime ;
      at.wid := 50 ;
      at.pn  := 6 ;
      at.pt[0] := 10.0 ;
      at.pt[1] :=  3.0 ;
      at.pt[2] :=  1.0 ;
      at.pt[3] :=  3.0 ;
      at.pt[4] :=  1.0 ;
      at.pt[5] :=  3.0 ;
      at.pit := 0.0 ;
      for i:=0 to at.pn-1 do
         at.pit := at.pit + at.pt[i] ;
      GL_Arc(Canvas, 0,0,150,45,225, cl, at);

      at.col := clFuchsia ;
      at.wid := 100 ;
      at.pn  := 8 ;
      at.pt[0] := 10.0 ;
      at.pt[1] :=  2.0 ;
      at.pt[2] :=  1.0 ;
      at.pt[3] :=  2.0 ;
      at.pt[4] :=  0.0 ;
      at.pt[5] :=  2.0 ;
      at.pt[6] :=  1.0 ;
      at.pt[7] :=  2.0 ;
      at.pit := 0.0 ;
      for i:=0 to at.pn-1 do
         at.pit := at.pit + at.pt[i] ;
      GL_Arc(Canvas, 0,0,150,225,45, cl, at);

      //GText(Canvas, 0, 0,12,12,0,0,0,'lr SVbN','eXgTEST');
      //GText(Canvas, 0,20,24,12,0,1,0,'lr SVbN','eXgTEST');
      //GText(Canvas, 0,40,12,24,0,0,1,'lr ','eXgTEST');
      //GText(Canvas, 0,80,12,12,100,0,0,'lr ','eXgTEST');
      at.col := clGreen ;
      GL_Text1(Canvas, 0,0,10,10,0,0,0,0,'lr ','eXgTEST',at,cl);
      GL_Text1(Canvas, 0,0,20,10,3,0,6,1,'lr ','eXgTEST',at,cl);
      GL_Text1(Canvas, 0,0,10,20,6,-30,2,2,'lr SVbN','eXgTEST',at,cl);
      GL_Text1(Canvas, 0,0,10,10,6,30,8,28,'lr SVbN','eXgTEST',at,cl);

      GPenSet(Canvas,clOlive,0,0) ;
      w1 := 5/LogicScale ;
      GLLine(Canvas, 200-w1,0 , 200+w1,0 , cl);
      GLLine(Canvas, 200,-w1 , 200,w1 , cl) ;
      at.col := clOlive ;
      GL_Text2(Canvas, 200,0,10,10,0,0,2,0,'lr ','eXgTEST',at,cl);
      GL_Text2(Canvas, 200,0,20,10,3,0,0,1,'lr ','eXgTEST',at,cl);
      GL_Text2(Canvas, 200,0,10,20,6,-30,8,6,'lr SVbN','eXgTEST',at,cl);
      GL_Text2(Canvas, 200,0,10,10,6,30,6,28,'lr SVbN','eXgTEST',at,cl);
   end;
	// yCgp摜
	RepBmp.Free ;
   RepBmp := nil ;
   try
      RepBmp := TBitmap.Create ;
		RepBmp.Width := PaintBox1.Width ;
      RepBmp.Height:= PaintBox1.Height ;
      BitBlt(RepBmp.Canvas.Handle,0,0,RepBmp.Width,RepBmp.Height,PaintBox1.Canvas.Handle,0,0,SRCCOPY);
 	except
     	RepBmp.Free ;
     	RepBmp := nil ;
   end;

   MouseWheelCheck := False ;
   MouseWheelFlag  := False ;
end;

// ʊg
procedure TForm13.dispZoom(x1,y1,x2,y2:double) ;
var
   w1,w2 : double ;
   cx,cy : double ;
   Wndx,Wndy : double ;
begin
   BLogicScale := LogicScale ;
   BLogicWx1 := LogicWx1 ;
   BLogicWy1 := LogicWy1 ;
   BLogicWx2 := LogicWx2 ;
   BLogicWy2 := LogicWy2 ;

	Phsx := PaintBox1.Width ;
   Phsy := PaintBox1.Height ;

	Wndx := Abs(x2 - x1) ;
   Wndy := Abs(y2 - y1) ;
   if (Wndx <= 0.0000001) then Wndx := 0.0000001 ;
   if (Wndy <= 0.0000001) then Wndy := 0.0000001 ;
	w1 := Phsx/Wndx ;
	w2 := Phsy/Wndy ;
  	if (w1 < w2) then
   	LogicScale := w1
	else
   	LogicScale := w2 ;		// 1mm̃hbg
	w1 := 0.5 * Phsx / LogicScale ;
   w2 := 0.5 * Phsy / LogicScale ;
	cx := (x1 + x2) / 2.0 ;
	cy := (y1 + y2) / 2.0 ;
   LogicWx1 := cx - w1 ;
   LogicWy1 := cy - w2 ;
   LogicWx2 := cx + w1 ;
   LogicWy2 := cy + w2 ;

   dispDrawAll ;
end;

// ʏk
procedure TForm13.dispZoomDown(x1,y1,x2,y2:double) ;
var
	w1,w2 : double ;
   cx,cy : double ;
   Wndx,Wndy : double ;
begin
   BLogicScale := LogicScale ;
   BLogicWx1 := LogicWx1 ;
   BLogicWy1 := LogicWy1 ;
   BLogicWx2 := LogicWx2 ;
   BLogicWy2 := LogicWy2 ;

	Phsx := PaintBox1.Width ;
   Phsy := PaintBox1.Height ;

	w1 := LogicWx2 - LogicWx1 ;
   w2 := LogicWy2 - LogicWy1 ;
	Wndx := Abs(x2 - x1) ;
   Wndy := Abs(y2 - y1) ;
   if (Wndx <= 0.0000001) then Wndx := 0.0000001 ;
   if (Wndy <= 0.0000001) then Wndy := 0.0000001 ;
	w1 := w1 / Wndx ;
	w2 := w2 / Wndy ;
	Wndx := Wndx * w1 * 2.0 ;
   Wndy := Wndy * w2 * 2.0 ;
	w1 := Phsx/Wndx ;
	w2 := Phsy/Wndy ;
  	if (w1 < w2) then
   	LogicScale := w1
	else
   	LogicScale := w2 ;		// 1mm̃hbg
	w1 := 0.5 * Phsx / LogicScale ;
   w2 := 0.5 * Phsy / LogicScale ;
	cx := (x1 + x2) / 2.0 ;
	cy := (y1 + y2) / 2.0 ;
   LogicWx1 := cx - w1 ;
   LogicWy1 := cy - w2 ;
   LogicWx2 := cx + w1 ;
   LogicWy2 := cy + w2 ;

   dispDrawAll ;
end;

// ʈړ
procedure TForm13.dispMove(x1,y1:double) ;
var
   w1,w2 : double ;
   cx,cy : double ;
begin
   BLogicScale := LogicScale ;
   BLogicWx1 := LogicWx1 ;
   BLogicWy1 := LogicWy1 ;
   BLogicWx2 := LogicWx2 ;
   BLogicWy2 := LogicWy2 ;

	Phsx := PaintBox1.Width ;
   Phsy := PaintBox1.Height ;

	cx := (LogicWx1 + LogicWx2) / 2.0 ;
	cy := (LogicWy1 + LogicWy2) / 2.0 ;
	w1 := x1 - cx ;
   w2 := y1 - cy ;
   LogicWx1 := LogicWx1 + w1 ;
   LogicWy1 := LogicWy1 + w2 ;
   LogicWx2 := LogicWx2 + w1 ;
   LogicWy2 := LogicWy2 + w2 ;

   dispDrawAll ;
end;

end.
